'use strict';

var _yeomanEnvironment = require('yeoman-environment');

var _yeomanEnvironment2 = _interopRequireDefault(_yeomanEnvironment);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _meta = require('generator-feathers/meta');

var _meta2 = _interopRequireDefault(_meta);

var _semver = require('semver');

var _semver2 = _interopRequireDefault(_semver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var env = _yeomanEnvironment2.default.createEnv();

var feathersGenerators = 'generator-feathers/generators';

Object.keys(_meta2.default).forEach(function (name) {
  var moduleName = name === 'plugin' ? 'generator-feathers-plugin' : feathersGenerators + '/' + name;
  env.register(require.resolve(moduleName), 'feathers:' + name);
});

module.exports = function (argv) {
  var generatorOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    disableNotifyUpdate: true
  };

  var description = 'Run a generator. Type can be\n';

  Object.keys(_meta2.default).forEach(function (name) {
    description += '\t\u2022 ' + name + ' - ' + _meta2.default[name] + '\n';
  });

  _commander2.default.version(require('../package.json').version).usage('generate [type]');

  console.error('WARNING: This version of the Feathers CLI is deprecated and no longer maintained. Please use @feathersjs/cli instead. See https://docs.feathersjs.com/migrating.html for more information.');

  if (!_semver2.default.satisfies(process.version, '>= 6.0.0')) {
    console.error('The Feathers CLI and generated application requires Node v6.0.0 or later.');
    return process.exit(1);
  }

  _commander2.default.command('generate [type]').alias('g').description(description).action(function (type) {
    if (!type) {
      _commander2.default.help();
    } else {
      env.run('feathers:' + type, generatorOptions);
    }
  });

  _commander2.default.command('*').action(function () {
    return _commander2.default.help();
  });
  _commander2.default.parse(argv);

  if (argv.length === 2) {
    _commander2.default.help();
  }
};